#undef __
#ifdef __STDC__
#define __(x) x
#else
#define __(x) ()
#endif

/* signal handling */
extern void catch_signals __((void (* catchfunc) (void)));
extern void suspendmyself __((void));

/* tty handling */
extern void raw_mode __((FLAG state));
extern void start_screen_mode __((void));
extern void end_screen_mode __((void));
extern void get_term __((void));
extern void getwinsize __((void));

/* i/o handling */
extern void flush __((void));
extern int inputreadyafter __((int fid, int msec));
extern int __readchar __((void));

/* screen mode handling */
#ifdef msdos
extern void set_video_lines __((int r));
	/* 0/1/2: 200/350/400 lines */
extern void set_grafmode_height __((int r, int l));
	/* 0/1/2: font height 8/14/16 ; 1/2/3/n: 14/25/43/n lines */
extern void set_fontbank __((int f));
	/* 0..7 */
#endif
extern void set_textmode_height __((int r));
	/* 0/1/2: font height 8/14/16 */
extern void set_font_height __((int r));
	/* set font height in character pixels, <= 32 */
extern void set_screen_mode __((int mode));
extern void resize_the_screen __((FLAG sb, FLAG keep_columns));
extern void switch_textmode_height __((FLAG cycle));
	/* True: cycle through font heights 8/14/16 
	   False: switch between font heights 8/16 */

/* screen manipulation */
extern void clear_screen __((void));
extern void clear_eol __((void));
extern void scroll_forward __((void));
extern void scroll_reverse __((void));
extern void add_line __((int));
extern void delete_line __((int));
extern void move_cursor __((int, int));

/* screen output */
extern void putstring __((char *));
extern void __putchar __((character));
extern void ring_bell __((void));
extern void putblockchar __((character));

/* screen attributes handling */
extern void disp_normal __((void));
extern void disp_colour __((int));
extern void reverse_on __((void));
extern void reverse_off __((void));
extern void altcset_on __((void));
extern void altcset_off __((void));
extern void start_extracset __((void));
extern void end_extracset __((void));
extern void dimon __((void));
extern void dimoff __((void));
extern void boldon __((void));
extern void boldoff __((void));
extern void unidisp_on __((void));
extern void unidisp_off __((void));
extern void ctrldisp_on __((void));
extern void ctrldisp_off __((void));
extern void menudisp_on __((void));
extern void menudisp_off __((void));
extern void dispHTML_code __((void));
extern void dispHTML_jsp __((void));
extern void dispHTML_comment __((void));
extern void dispHTML_off __((void));
extern void unimarkdisp_on __((void));
extern void unimarkdisp_off __((void));
extern void combiningdisp_on __((void));
extern void combiningdisp_off __((void));
extern void diagdisp_on __((void));
extern void diagdisp_off __((void));
extern void disp_scrollbar_foreground __((void));
extern void disp_scrollbar_background __((void));
extern void disp_scrollbar_off __((void));
extern void menuborder_on __((void));
extern void menuheader_on __((void));
extern void menuheader_off __((void));
extern void menuborder_off __((void));

/* keyboard functions */
extern int readchar __((void));
extern int readchar_nokeymap __((void));
extern int readchar_allbuttons __((void));
extern unsigned long readcharacter __((void));
extern int _readchar __((void));
extern int _readchar_nokeymap __((void));
extern int char_ready_within __((int));
extern void set_fkeymap __((char *));
extern void handleKeymapmenu __((int));
extern void handleQuotemenu __((int));

/* mouse handling functions */
extern void DIRECTcrttool __((void));
extern void DIRECTxterm __((void));
extern void TRACKxterm __((void));
extern void TRACKxtermT __((void));

extern void menu_mouse_mode __((FLAG));

/* keyboard mapping setup functions */
extern void toggleKEYMAP __((void));
extern void setupKEYMAP __((void));
extern void cycleKEYMAP __((void));
extern void setKEYMAP __((char *));
extern int get_string_nokeymap __((char *, char *, FLAG, char *));
extern char * keyboard_mapping;

